﻿B4J=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=6.47
@EndOfDesignText@
Sub Class_Globals
	Private fx As JFX
	'this will hold all our rows
	Private Rows As Map
	'this will hold temporal columns
	Private Cells As Map
	'this will hold each row definition
	Type WebRow(Rows As Int, MarginTop As Int, MarginBottom As Int, MarginLeft As Int, MarginRight As Int, PaddingTop As Int, PaddingBottom As Int, PaddingLeft As Int, PaddingRight As Int, Columns As List)
	Type WebColumn(Columns As Int,  OffsetSmall As Int, OffsetMedium As Int, OffsetLarge As Int, OffsetXLarge As Int, SpanSmall As Int, SpanMedium As Int, SpanLarge As Int, SpanXLarge As String, MarginTop As Int, _
	MarginBottom As Int, MarginLeft As Int, MarginRight As Int, PaddingTop As Int, PaddingBottom As Int, PaddingLeft As Int, PaddingRight As Int)
	'hold our last row
	Private LastRow As Int
	'column defs for bootstrap
	Private colClass As Map = CreateMap("s": "col-sm-","m":"col-md-","l":"col-lg-","x":"col-xl-")
	'padding def
	Private padClass As Map = CreateMap("pt":"pt-","pb":"pb-","pl":"pl-","pr":"pr-")
	'margin class
	Private marClass As Map = CreateMap("mt":"mt-","mb":"mb-","ml":"ml-","mr":"mr-")
	'temporal holder
	Private RC As Map
	Private rowClass As String = "row"
	'show the RC on the column text
	Public ShowID As Boolean
End Sub

'Initializes the BootstrapGrid
Public Sub Initialize
	Rows.Initialize 
	Rows.clear
	LastRow = 0
	RC.Initialize 
	RC.clear
	Cells.Initialize 
	Cells.clear
	ShowID = False
End Sub

'Add a specic number of rows, the following method should be AddColumns
Sub AddRows(Rows2Add As Int) As BootstrapGrid
	'if there is no existing row, then initialize the map
	If Rows.IsInitialized = False Then Rows.Initialize
	'lets store the last row
	LastRow = Rows.size
	'create a new type
	Dim nRow As WebRow
	'initiliaze it
	nRow.Initialize
	nRow.Rows = Rows2Add
	nRow.MarginTop = 0
	nRow.MarginBottom = 0
	nRow.MarginLeft = 0
	nRow.MarginRight = 0
	nRow.PaddingBottom = 0
	nRow.PaddingLeft = 0
	nRow.PaddingTop = 0
	nRow.PaddingRight = 0
	nRow.Columns.Initialize
	'lets store this new row in rows
	Dim rowKey As String = $"R${LastRow}"$
	'lets save the row on the map
	Rows.Put(rowKey,nRow)
	Return Me
End Sub

'set the row margins, the row should exist
Sub SetRowMargins(RowPos As Int, MarginTop As Int, MarginBottom As Int, MarginLeft As Int, MarginRight As Int) As BootstrapGrid
	Dim rowKey As String = $"R${RowPos}"$
	If Rows.ContainsKey(rowKey) Then
		Dim row As WebRow = Rows.Get(rowKey)
		row.MarginTop = MarginTop
		row.MarginBottom = MarginBottom
		row.MarginLeft = MarginLeft
		row.MarginRight = MarginRight
		Rows.Put(rowKey,row)
	End If
	Return Me
End Sub

'set the column margins using RC, the RC should be the actual position
Sub SetColumnMargins(RowPos As Int, ColPos As Int, MarginTop As Int, MarginBottom As Int, MarginLeft As Int, MarginRight As Int) As BootstrapGrid
	'define the column key
	Dim cellKey As String = $"R${RowPos}C${ColPos}"$
	'define the column
	Dim cell As WebColumn
	If Cells.ContainsKey(cellKey) Then
		'something was already changed about the column
		cell = Cells.Get(cellKey)
	Else
		cell.Initialize
	End If 
	cell.MarginTop = MarginTop
	cell.MarginBottom = MarginBottom
	cell.MarginLeft = MarginLeft
	cell.MarginRight = MarginRight
	Cells.Put(cellKey,cell)
	Return Me
End Sub

'set the row padding, the row should exist
Sub SetRowPadding(RowPos As Int, PaddingTop As Int, PaddingBottom As Int, PaddingLeft As Int, PaddingRight As Int) As BootstrapGrid
	Dim rowKey As String = $"R${RowPos}"$
	If Rows.ContainsKey(rowKey) Then
		Dim row As WebRow = Rows.Get(rowKey)
		row.PaddingTop = PaddingTop
		row.PaddingBottom = PaddingBottom
		row.PaddingLeft = PaddingLeft
		row.PaddingRight = PaddingRight
		Rows.Put(rowKey,row)
	End If
	Return Me
End Sub

'set the column padding, the RC should be the actual position
Sub SetColumnPadding(RowPos As Int, ColPos As Int, PaddingTop As Int, PaddingBottom As Int, PaddingLeft As Int, PaddingRight As Int) As BootstrapGrid
	Dim cellKey As String = $"R${RowPos}C${ColPos}"$
	Dim cell As WebColumn
	If Cells.ContainsKey(cellKey) Then
		cell = Cells.Get(cellKey)
	Else
		cell.Initialize 
	End If
	cell.PaddingTop = PaddingTop
	cell.PaddingBottom = PaddingBottom
	cell.PaddingLeft = PaddingLeft
	cell.PaddingRight = PaddingRight
	Cells.Put(cellKey,cell)
	Return Me
End Sub

'add a number of columns specifying their spans, use with AddRows
Sub AddColumns(Columns2Add As Int, SpanSmall As Int, SpanMedium As Int, SpanLarge As Int, SpanXLarge As String) As BootstrapGrid
	'add a column to the last row added
	Dim nCell As WebColumn
	nCell.Initialize
	nCell.Columns = Columns2Add
	nCell.OffsetSmall = 0
	nCell.OffsetMedium = 0
	nCell.OffsetLarge = 0
	nCell.OffsetXLarge = 0
	nCell.SpanSmall = SpanSmall
	nCell.SpanMedium = SpanMedium
	nCell.SpanLarge = SpanLarge
	nCell.SpanXLarge = SpanXLarge
	nCell.MarginTop = 0
	nCell.MarginBottom = 0
	nCell.MarginLeft = 0
	nCell.MarginRight = 0
	nCell.PaddingBottom = 0
	nCell.PaddingLeft = 0
	nCell.PaddingTop = 0
	nCell.PaddingRight = 0
	'get the existing columns for this row
	Dim rowkey As String = $"R${LastRow}"$
	'get the row from existing rows
	If Rows.ContainsKey(rowkey) Then
		'get the row from existing rows
		Dim oldRow As WebRow = Rows.Get(rowkey)
		'get the existing columns from the row
		oldRow.columns.Add(nCell)
		Rows.Put(rowkey,oldRow)
	Else
		LogError("AddColumns: A row has not been added yet to the grid!")
	End If
	Return Me 
End Sub

'returns the grid definition
Sub ToString() As String
	'hold row counter
	LastRow = 0
	Dim sb As StringBuilder
	sb.Initialize 
	'for each defined row, for each defined column
	Dim rowCnt As Int = 0
	Dim rowTot As Int = Rows.Size - 1
	For rowCnt = 0 To rowTot
		'get this row
		Dim currentRow As WebRow = Rows.GetValueAt(rowCnt)
		sb.Append(BuildRow(currentRow)).append(CRLF)
	Next
	Return sb.tostring
End Sub

'build a single row
private Sub BuildRow(row As WebRow) As String
	'how many rows do we have to render
	Dim rowTot As Int = row.Rows
	Dim rowCnt As Int
	Dim sb As StringBuilder
	sb.Initialize
	'for each row
	For rowCnt = 1 To rowTot
		LastRow = LastRow + 1
		Dim rowKey As String = $"R${LastRow}"$
		sb.Append($"<div class="${BuildRowClass(row)}" id="${rowKey}">"$).Append(CRLF)
		'get the columns to add
		Dim cols As List = row.Columns 
		'how many columns to add here
		Dim colCnt As Int = 0
		Dim colTot As Int = cols.Size - 1
		'this will store the column count
		Dim LastColumn As Int = 0
		For colCnt = 0 To colTot
			'get this column
			Dim column As WebColumn = cols.Get(colCnt)
			Dim colCnt1 As Int = 0
			Dim colTot1 As Int = column.Columns
			For colCnt1 = 1 To colTot1
				'increment the column to add for this row
				LastColumn = LastColumn + 1 
				Dim cellKey As String = $"${rowKey}C${LastColumn}"$
				'add to RC map, this is used to check if Matrix Position Exist
				RC.Put(cellKey,cellKey)
				'if showid
				Dim strShow As String = ""
				If ShowID = True Then strShow = cellKey
				'define the column structure
				Dim sbCol As String = $"<div class="${BuildColumnClass(column)}" id="${cellKey}">${strShow}</div>"$
				sb.Append(sbCol).Append(CRLF)
			Next
		Next
		sb.Append("</div>").append(CRLF)
	Next
	Return sb.tostring
End Sub

'build the column class for current column
private Sub BuildColumnClass(col As WebColumn) As String
	Dim sb As StringBuilder
	sb.Initialize
	
	'add the spans
	sb.Append(BuildSpans(col.SpanSmall,col.SpanMedium,col.SpanLarge,col.SpanXLarge))
	'add the margins
	sb.Append(BuildMargins(col.MarginTop,col.MarginBottom,col.MarginLeft,col.MarginRight))
	'add the padding
	sb.Append(BuildPadding(col.PaddingTop,col.PaddingBottom,col.PaddingLeft,col.PaddingRight))
	
	Return sb.tostring.trim
End Sub

'build the row class for current row
private Sub BuildRowClass(row As WebRow) As String
	Dim sb As StringBuilder
	sb.Initialize 
	sb.Append($"${rowClass} "$)
	'add the margins
	sb.Append(BuildMargins(row.MarginTop,row.MarginBottom,row.MarginLeft,row.MarginRight))
	'add the padding
	sb.Append(BuildPadding(row.PaddingTop,row.PaddingBottom,row.PaddingLeft,row.PaddingRight))
	Return sb.tostring.trim
End Sub

'build the spans class
Private Sub BuildSpans(SS As Int, SM As Int, SL As Int, SXL As Int) As String
	Dim sb As StringBuilder
	sb.Initialize
	'add the sizes
	For Each colKey As String In colClass.keys
		'get the defined column class prefix
		Dim colC As String = colClass.Get(colKey)
		sb.Append(colC)
		'for each size append the span size
		Select Case colKey
			Case "s"
				sb.Append(SS)
			Case "m"
				sb.Append(SM)
			Case "l"
				sb.Append(SL)
			Case "x"
				sb.Append(SXL)
		End Select
		sb.Append(" ")
	Next
	Return sb.ToString
End Sub

'build the padding class
Private Sub BuildPadding(PT As Int, PB As Int, PL As Int, PR As Int) As String
	Dim sb As StringBuilder
	sb.Initialize 	
	'loop through each padding class
	For Each colKey As String In padClass.Keys
		Dim colC As String = padClass.Get(colKey)
		sb.Append(colC)
		Select Case colKey
			Case "pt"
				sb.Append(PT)
			Case "pb"
				sb.Append(PB)
			Case "pl"
				sb.Append(PL)
			Case "pr"
				sb.Append(PR)
		End Select
		sb.Append(" ")
	Next
	Return sb.tostring
End Sub

'build the margins class
Private Sub BuildMargins(MT As Int, MB As Int, ML As Int, MR As Int) As String
	Dim sb As StringBuilder
	sb.Initialize
	'loop through each margin class
	For Each colKey As String In marClass.Keys
		Dim colC As String = marClass.Get(colKey)
		sb.Append(colC)
		Select Case colKey
			Case "mt"
				sb.Append(MT)
			Case "mb"
				sb.Append(MB)
			Case "ml"
				sb.Append(ML)
			Case "mr"
				sb.Append(MR)
		End Select
		sb.Append(" ")
	Next
	Return sb.tostring 
End Sub

'check if the row exists
Sub RowExists(rowPos As Int) As Boolean
	Dim rowcol As String = $"R${rowPos}"$
	Return Rows.ContainsKey(rowcol)
End Sub

'check if the column exist
Sub ColumnExists(rowPos As Int, colPos As Int) As Boolean
	Dim rowcol As String = $"R${rowPos}C${colPos}"$
	Return RC.ContainsKey(rowcol) 
End Sub

'how many rows do we have
Sub HowManyRows() As Int
	Return LastRow
End Sub